# Uses of Interface
org.springframework.http.codec.HttpMessageWriter

Packages that use HttpMessageWriter
Package
Description
org.springframework.http.codec
Provides implementations of `Encoder` and `Decoder` for web use.
org.springframework.http.codec.multipart
Multipart support.
org.springframework.http.codec.protobuf
Provides an encoder and a decoder for Google Protocol Buffers.

## Uses of HttpMessageWriter in org.springframework.http.codec

Classes in org.springframework.http.codec that implement HttpMessageWriter
Modifier and Type
Class
Description
`class`
`EncoderHttpMessageWriter<T>`
`HttpMessageWriter` that wraps and delegates to an `Encoder`.
`class`
`FormHttpMessageWriter`
`HttpMessageWriter` for writing a `MultiValueMap<String, String>` as HTML form data, i.e.
`class`
`ResourceHttpMessageWriter`
`HttpMessageWriter` that can write a `Resource` from both client and server perspectives.
`class`
`ServerSentEventHttpMessageWriter`
`HttpMessageWriter` for `"text/event-stream"` responses.
Methods in org.springframework.http.codec that return types with arguments of type HttpMessageWriter
Modifier and Type
Method
Description
`List<HttpMessageWriter<?>>`
CodecConfigurer.`getWriters()`
Obtain the configured HTTP message writers.
Methods in org.springframework.http.codec with parameters of type HttpMessageWriter
Modifier and Type
Method
Description
`void`
CodecConfigurer.CustomCodecs.`writer(HttpMessageWriter<?> writer)`
Deprecated.
as of 5.1.13, use `CodecConfigurer.CustomCodecs.register(Object)` or `CodecConfigurer.CustomCodecs.registerWithDefaultConfig(Object)` instead.
`CodecConfigurer.MultipartCodecs`
CodecConfigurer.MultipartCodecs.`writer(HttpMessageWriter<?> writer)`
Add a Part `HttpMessageWriter`.

## Uses of HttpMessageWriter in org.springframework.http.codec.multipart

Classes in org.springframework.http.codec.multipart that implement HttpMessageWriter
Modifier and Type
Class
Description
`class`
`MultipartHttpMessageWriter`
`HttpMessageWriter` for writing a `MultiValueMap<String, ?>` as multipart form data, i.e.
`class`
`PartEventHttpMessageWriter`
`HttpMessageWriter` for writing `PartEvent` objects.
`class`
`PartHttpMessageWriter`
`HttpMessageWriter` for writing with `Part`.
Methods in org.springframework.http.codec.multipart that return HttpMessageWriter
Modifier and Type
Method
Description
`HttpMessageWriter<org.springframework.util.MultiValueMap<String,String>>`
MultipartHttpMessageWriter.`getFormWriter()`
Return the configured form writer.
Methods in org.springframework.http.codec.multipart that return types with arguments of type HttpMessageWriter
Modifier and Type
Method
Description
`List<HttpMessageWriter<?>>`
MultipartHttpMessageWriter.`getPartWriters()`
Return the configured part writers.
Constructors in org.springframework.http.codec.multipart with parameters of type HttpMessageWriter
Modifier
Constructor
Description
``
`MultipartHttpMessageWriter(Supplier<List<HttpMessageWriter<?>>> partWritersSupplier, HttpMessageWriter<org.springframework.util.MultiValueMap<String,String>> formWriter)`
Constructor with a supplier for an explicit list of writers for serializing parts and a writer for plain form data to fall back when no media type is specified and the actual map consists of String values only.
``
`MultipartHttpMessageWriter(List<HttpMessageWriter<?>> partWriters, HttpMessageWriter<org.springframework.util.MultiValueMap<String,String>> formWriter)`
Constructor with explicit list of writers for serializing parts and a writer for plain form data to fall back when no media type is specified and the actual map consists of String values only.
Constructor parameters in org.springframework.http.codec.multipart with type arguments of type HttpMessageWriter
Modifier
Constructor
Description
``
`MultipartHttpMessageWriter(Supplier<List<HttpMessageWriter<?>>> partWritersSupplier, HttpMessageWriter<org.springframework.util.MultiValueMap<String,String>> formWriter)`
Constructor with a supplier for an explicit list of writers for serializing parts and a writer for plain form data to fall back when no media type is specified and the actual map consists of String values only.
``
`MultipartHttpMessageWriter(List<HttpMessageWriter<?>> partWriters)`
Constructor with explicit list of writers for serializing parts.
``
`MultipartHttpMessageWriter(List<HttpMessageWriter<?>> partWriters, HttpMessageWriter<org.springframework.util.MultiValueMap<String,String>> formWriter)`
Constructor with explicit list of writers for serializing parts and a writer for plain form data to fall back when no media type is specified and the actual map consists of String values only.

## Uses of HttpMessageWriter in org.springframework.http.codec.protobuf

Classes in org.springframework.http.codec.protobuf that implement HttpMessageWriter
Modifier and Type
Class
Description
`class`
`ProtobufHttpMessageWriter`
`HttpMessageWriter` that can write a protobuf `Message` and adds `X-Protobuf-Schema`, `X-Protobuf-Message` headers and a `delimited=true` parameter is added to the content type if a flux is serialized.